#lang racket

(define split
  ; precondition: (<= n (length lst))
  (lambda (lst n)
    (cons (take lst n) (drop lst n))))

; -----------------------------------------------------------------

(define crossover
  (lambda (p1 p2)
    (let ((point (random (add1 (length p1)))))
      (if (< 0.5 (random))
          (append (take p1 point)
                  (drop p2 point))
          (append (take p2 point)
                  (drop p1 point))))))

(define mutate
  (lambda (p)
    (let ((pos (random (sub1 (length p)))))
      (let ((front (take p pos))
            (back  (drop p (add1 pos))))
          (append front (cons (random-op) back))))))

(define *operators*
  '(drop dup swap dip cons swcons rollupd rollup + - * / // first rest))

(define random-op
  (lambda ()
    (list-ref *operators* (random (length *operators*)))))
 