#lang racket
(provide postfix)

; A simple postfix interpreter for *binary* operators

(define postfix
  (lambda words
    (eval-postfix words '())))

(define eval-postfix
  (lambda (program stack)
    (if (null? program)
        stack
        (let ((top  (first program))
              (next (rest program)))
          (eval-postfix next
            (if (not (procedure? top))
                (cons top stack)
                (let ((arg2 (first stack))
                      (arg1 (second stack))
                      (rest (rest (rest stack))))
                  (cons (top arg1 arg2) rest))))))))
